"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlCardVariant = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable @typescript-eslint/no-namespace */
var react_1 = require("react");
var Typography_1 = require("onyxia-ui/Typography");
var tss_react_1 = require("tss-react");
var GlButton_1 = require("./GlButton");
var theme_1 = require("./theme");
var powerhooks_1 = require("powerhooks");
var getUseClassNames = function () {
    var createUseClassNames = theme_1.getThemeApi().createUseClassNames;
    var useClassNames = createUseClassNames()(function (theme, _a) {
        var background = _a.background, button = _a.button;
        return ({
            "root": __assign(__assign({ "borderRadius": 16, "minHeight": 591 }, (theme.responsive.down(1440)
                ? {
                    "minHeight": 412,
                }
                : {})), { "display": "flex", "flexDirection": "column", "overflow": "hidden" }),
            "tagWithBackground": {
                "background": (function () {
                    if (background === undefined) {
                        return theme.isDarkModeEnabled
                            ? theme.colors.palette.dark.greyVariant3
                            : theme.colors.palette.light.greyVariant3;
                    }
                    if (background.type === "color") {
                        return background.color;
                    }
                    return "url(" + background.url + ") no-repeat center";
                })(),
                "backgroundSize": "cover",
            },
            "footer": {
                "backgroundColor": theme.isDarkModeEnabled
                    ? theme.colors.palette.dark.greyVariant1
                    : theme.colors.palette.light.light,
                "paddingLeft": theme.spacing(3),
                "paddingRight": theme.spacing(3),
                "paddingTop": theme.spacing(2),
                "paddingBottom": theme.spacing(2),
                "& h5": {
                    "marginBottom": theme.spacing(1.25),
                },
                "& h6:nth-child(2)": {
                    "marginBottom": 10,
                },
            },
            "header": {
                "flex": 1,
                "width": "100%",
                "margin": 0,
            },
            "buttonWrapper": __assign({ "display": "flex", "justifyContent": "flex-end", "& button": {} }, (function () {
                var value = theme.spacing(2);
                return {
                    "paddingTop": value,
                    "paddingRight": value,
                };
            })()),
            "button": button === undefined
                ? {}
                : {
                    "alignSelf": "right",
                    "color": button.color + " !important",
                    "borderColor": "unset !important",
                    "backgroundColor": button.backgroundColor + " !important",
                    "border": "unset !important",
                },
        });
    }).useClassNames;
    return { useClassNames: useClassNames };
};
exports.GlCardVariant = react_1.memo(function (props) {
    var className = props.className, background = props.background, button = props.button, footer = props.footer;
    var useClassNames = powerhooks_1.useGuaranteedMemo(function () { return getUseClassNames(); }, []).useClassNames;
    var classNames = useClassNames({
        background: background,
        button: button,
    }).classNames;
    return (jsx_runtime_1.jsxs("div", __assign({ className: tss_react_1.cx(classNames.root, className) }, { children: [jsx_runtime_1.jsx("div", __assign({ className: tss_react_1.cx(classNames.tagWithBackground, classNames.header) }, { children: jsx_runtime_1.jsx("div", __assign({ className: classNames.buttonWrapper }, { children: button !== undefined && (jsx_runtime_1.jsx(GlButton_1.GlButton, __assign({ href: button.href, className: classNames.button }, { children: button.title }), void 0)) }), void 0) }), void 0),
            footer !== undefined && (jsx_runtime_1.jsxs("div", __assign({ className: classNames.footer }, { children: [footer.title !== undefined && jsx_runtime_1.jsx(Typography_1.Typography, __assign({ variant: "h5" }, { children: footer.title }), void 0),
                    footer.subTitle !== undefined && (jsx_runtime_1.jsx(Typography_1.Typography, __assign({ variant: "subtitle1" }, { children: footer.subTitle }), void 0)),
                    footer.date !== undefined && (jsx_runtime_1.jsx(Typography_1.Typography, __assign({ variant: "subtitle1" }, { children: footer.date }), void 0))] }), void 0))] }), void 0));
});
//# sourceMappingURL=GlCardVariant.js.map