/// <reference types="react" />
export declare type GlHeaderProps = {
    /**
     * If you use an svg image that does not have a fill,
     * the fill will be set to the current font color,
     * depending on the dark mode being active.
     */
    title?: GlHeaderProps.Title;
    menuItems?: {
        name: string;
        url: string;
    }[];
    className?: string;
};
export declare namespace GlHeaderProps {
    type Title = Title.Logo | Title.Markdown;
    namespace Title {
        type Logo = {
            type: "logo";
            logoUrl: string;
        };
        type Markdown = {
            type: "markdown";
            markdown: string;
        };
    }
}
export declare const GlHeader: import("react").MemoExoticComponent<(props: GlHeaderProps) => JSX.Element>;
