"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Section = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable @typescript-eslint/no-namespace */
var Typography_1 = require("onyxia-ui/Typography");
var react_markdown_1 = __importDefault(require("react-markdown"));
var GlImage_1 = require("./GlImage");
var react_1 = require("react");
var tss_react_1 = require("tss-react");
var GlCode_1 = require("./GlCode");
var GlButton_1 = require("./GlButton");
var theme_1 = require("./theme");
var powerhooks_1 = require("powerhooks");
var GlCardSection_1 = require("./GlCardSection");
var getUseClassNames = function () {
    var createUseClassNames = theme_1.getThemeApi().createUseClassNames;
    var useClassNames = createUseClassNames()(function (theme, _a) {
        var _b, _c, _d;
        var isRowReverse = _a.isRowReverse;
        return ({
            "root": {
                "position": "relative",
                "marginTop": theme.spacing(17.25),
            },
            "smallThumbNails": {
                "display": "flex",
                "flexWrap": "wrap",
                "flexDirection": "row",
                "justifyContent": "center",
                "marginBottom": theme.spacing(17.25),
                "& >div": {
                    "margin": theme.spacing(1.5),
                },
            },
            "title": __assign({ "fontSize": "40px", "textAlign": "center", "marginBottom": theme.spacing(7.5) }, (theme.responsive.down("sm")
                ? {
                    "textAlign": "left",
                    "paddingLeft": theme.spacing(4.5),
                    "paddingRight": theme.spacing(4.5),
                }
                : {})),
            "articleAndImageWrapper": __assign({ "display": "flex", "justifyContent": "center", "alignItems": "center", "marginTop": theme.spacing(17.25) }, (theme.responsive.down("sm")
                ? {
                    "flexDirection": "column-reverse",
                    "paddingLeft": theme.spacing(4.5),
                    "paddingRight": theme.spacing(4.5),
                }
                : {
                    "flexDirection": isRowReverse ? "row-reverse" : "row",
                    "paddingLeft": theme.spacing(6),
                    "paddingRight": theme.spacing(6),
                })),
            "article": __assign((_b = { "display": "flex", "flexDirection": "column", "textAlign": "left" }, _b[isRowReverse ? "marginLeft" : "marginRight"] = theme.spacing(theme.responsive.down("md") ? 1.5 : 16), _b["width"] = theme.responsive.down("md") ? 302 : 412, _b["& h2"] = {
                "marginBottom": 14,
            }, _b["& p"] = {
                "fontSize": theme.typography.body1.fontSize,
                "lineHeight": "24px",
                "marginTop": 14,
                "marginBottom": 14,
            }, _b), (theme.responsive.down("sm")
                ? {
                    "width": "100%",
                    "margin": "unset",
                    "marginTop": theme.spacing(4),
                }
                : {})),
            "illustration": __assign(__assign((_c = { "width": 900 }, _c[isRowReverse ? "marginRight" : "marginLeft"] = theme.spacing(16), _c), (theme.responsive.down("md")
                ? (_d = {},
                    _d[isRowReverse ? "marginRight" : "marginLeft"] = theme.spacing(1.5),
                    _d["width"] = 464,
                    _d) : {})), (theme.responsive.down("sm")
                ? {
                    "margin": "unset",
                    "width": "100%",
                }
                : {})),
            "button": {
                "color": "unset !important",
                "backgroundColor": "unset !important",
                "borderColor": "unset !important",
                "alignSelf": "right",
            },
        });
    }).useClassNames;
    return { useClassNames: useClassNames };
};
exports.Section = react_1.memo(function (props) {
    var article = props.article, illustration = props.illustration, isRowReverse = props.isRowReverse, className = props.className, cardSection = props.cardSection, title = props.title;
    var useClassNames = powerhooks_1.useGuaranteedMemo(function () { return getUseClassNames(); }, []).useClassNames;
    var classNames = useClassNames({
        isRowReverse: isRowReverse,
    }).classNames;
    return (jsx_runtime_1.jsxs("section", __assign({ className: tss_react_1.cx(classNames.root, className) }, { children: [title && (jsx_runtime_1.jsx(Typography_1.Typography, __assign({ className: classNames.title, variant: "h2" }, { children: title }), void 0)),
            jsx_runtime_1.jsx(GlCardSection_1.GlCardSection, __assign({}, cardSection), void 0),
            jsx_runtime_1.jsxs("article", __assign({ className: classNames.articleAndImageWrapper }, { children: [article && (jsx_runtime_1.jsxs("div", __assign({ className: classNames.article }, { children: [jsx_runtime_1.jsx(Typography_1.Typography, __assign({ variant: "h2" }, { children: article.title }), void 0),
                            jsx_runtime_1.jsx(react_markdown_1.default, { children: article.paragraphMd }, void 0),
                            article.button && (jsx_runtime_1.jsx("div", __assign({ className: tss_react_1.cx(tss_react_1.css({
                                    "display": "flex",
                                    "justifyContent": "flex-end",
                                    "marginTop": 14,
                                }), article.button.className) }, { children: jsx_runtime_1.jsx(GlButton_1.GlButton, __assign({ className: classNames.button, type: "submit", href: article.button.href }, { children: article.button.title }), void 0) }), void 0))] }), void 0)),
                    illustration &&
                        (illustration.type === "image" ? (jsx_runtime_1.jsx(GlImage_1.GlImage, { url: illustration.url, alt: illustration.alt, className: tss_react_1.cx(classNames.illustration, illustration.className) }, void 0)) : (jsx_runtime_1.jsx(GlCode_1.GlCode, { text: illustration.text, language: illustration.language, showLineNumbers: illustration.showLineNumbers, className: tss_react_1.cx(classNames.illustration, illustration.className) }, void 0)))] }), void 0)] }), void 0));
});
//# sourceMappingURL=GlSection.js.map